#---
# Excerpted from "Genetic Algorithms in Elixir",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/smgaelixir for more book information.
#---
defmodule CrossoverTest do
  use ExUnit.Case
  use ExUnitProperties
  alias Types.Chromosome

  property "single_point/2 maintains the size of input chromosomes" do
    check all size <- integer(0..100),
              gene_1 <- list_of(integer(), length: size),
              gene_2 <- list_of(integer(), length: size) do
      p1 = %Chromosome{genes: gene_1, size: size}
      p2 = %Chromosome{genes: gene_2, size: size}
      {c1, c2} = Toolbox.Crossover.single_point(p1, p2)
      assert c1.size == size and c2.size == size
    end
  end
end
